<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for risultato StructType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: xs:anyType
 * @subpackage Structs
 */
class Risultato extends AbstractStructBase
{
    /**
     * The idswh
     * @var string
     */
    public $idswh;
    /**
     * The successo
     * Meta informations extracted from the WSDL
     * - nillable: true
     * @var bool
     */
    public $successo;
    /**
     * The errore
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $errore;
    /**
     * Constructor method for risultato
     * @uses Risultato::setIdswh()
     * @uses Risultato::setSuccesso()
     * @uses Risultato::setErrore()
     * @param string $idswh
     * @param bool $successo
     * @param string $errore
     */
    public function __construct($idswh = null, $successo = null, $errore = null)
    {
        $this
            ->setIdswh($idswh)
            ->setSuccesso($successo)
            ->setErrore($errore);
    }
    /**
     * Get idswh value
     * @return string|null
     */
    public function getIdswh()
    {
        return $this->idswh;
    }
    /**
     * Set idswh value
     * @param string $idswh
     * @return \StructType\Risultato
     */
    public function setIdswh($idswh = null)
    {
        // validation for constraint: string
        if (!is_null($idswh) && !is_string($idswh)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($idswh)), __LINE__);
        }
        $this->idswh = $idswh;
        return $this;
    }
    /**
     * Get successo value
     * @return bool|null
     */
    public function getSuccesso()
    {
        return $this->successo;
    }
    /**
     * Set successo value
     * @param bool $successo
     * @return \StructType\Risultato
     */
    public function setSuccesso($successo = null)
    {
        // validation for constraint: boolean
        if (!is_null($successo) && !is_bool($successo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($successo)), __LINE__);
        }
        $this->successo = $successo;
        return $this;
    }
    /**
     * Get errore value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getErrore()
    {
        return isset($this->errore) ? $this->errore : null;
    }
    /**
     * Set errore value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $errore
     * @return \StructType\Risultato
     */
    public function setErrore($errore = null)
    {
        // validation for constraint: string
        if (!is_null($errore) && !is_string($errore)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($errore)), __LINE__);
        }
        if (is_null($errore) || (is_array($errore) && empty($errore))) {
            unset($this->errore);
        } else {
            $this->errore = $errore;
        }
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Risultato
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
