<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for strutturaBean StructType
 * @subpackage Structs
 */
class StrutturaBean extends AbstractStructBase
{
    /**
     * The apertura
     * @var string
     */
    public $apertura;
    /**
     * The camereoccupate
     * @var string
     */
    public $camereoccupate;
    /**
     * The cameredisponibili
     * @var string
     */
    public $cameredisponibili;
    /**
     * The lettidisponibili
     * @var string
     */
    public $lettidisponibili;
    /**
     * Constructor method for strutturaBean
     * @uses StrutturaBean::setApertura()
     * @uses StrutturaBean::setCamereoccupate()
     * @uses StrutturaBean::setCameredisponibili()
     * @uses StrutturaBean::setLettidisponibili()
     * @param string $apertura
     * @param string $camereoccupate
     * @param string $cameredisponibili
     * @param string $lettidisponibili
     */
    public function __construct($apertura = null, $camereoccupate = null, $cameredisponibili = null, $lettidisponibili = null)
    {
        $this
            ->setApertura($apertura)
            ->setCamereoccupate($camereoccupate)
            ->setCameredisponibili($cameredisponibili)
            ->setLettidisponibili($lettidisponibili);
    }
    /**
     * Get apertura value
     * @return string|null
     */
    public function getApertura()
    {
        return $this->apertura;
    }
    /**
     * Set apertura value
     * @param string $apertura
     * @return \StructType\StrutturaBean
     */
    public function setApertura($apertura = null)
    {
        // validation for constraint: string
        if (!is_null($apertura) && !is_string($apertura)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($apertura)), __LINE__);
        }
        $this->apertura = $apertura;
        return $this;
    }
    /**
     * Get camereoccupate value
     * @return string|null
     */
    public function getCamereoccupate()
    {
        return $this->camereoccupate;
    }
    /**
     * Set camereoccupate value
     * @param string $camereoccupate
     * @return \StructType\StrutturaBean
     */
    public function setCamereoccupate($camereoccupate = null)
    {
        // validation for constraint: string
        if (!is_null($camereoccupate) && !is_string($camereoccupate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($camereoccupate)), __LINE__);
        }
        $this->camereoccupate = $camereoccupate;
        return $this;
    }
    /**
     * Get cameredisponibili value
     * @return string|null
     */
    public function getCameredisponibili()
    {
        return $this->cameredisponibili;
    }
    /**
     * Set cameredisponibili value
     * @param string $cameredisponibili
     * @return \StructType\StrutturaBean
     */
    public function setCameredisponibili($cameredisponibili = null)
    {
        // validation for constraint: string
        if (!is_null($cameredisponibili) && !is_string($cameredisponibili)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($cameredisponibili)), __LINE__);
        }
        $this->cameredisponibili = $cameredisponibili;
        return $this;
    }
    /**
     * Get lettidisponibili value
     * @return string|null
     */
    public function getLettidisponibili()
    {
        return $this->lettidisponibili;
    }
    /**
     * Set lettidisponibili value
     * @param string $lettidisponibili
     * @return \StructType\StrutturaBean
     */
    public function setLettidisponibili($lettidisponibili = null)
    {
        // validation for constraint: string
        if (!is_null($lettidisponibili) && !is_string($lettidisponibili)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($lettidisponibili)), __LINE__);
        }
        $this->lettidisponibili = $lettidisponibili;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\StrutturaBean
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
