<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for xmlImportRisultati StructType
 * @subpackage Structs
 */
class XmlImportRisultati extends AbstractStructBase
{
    /**
     * The risultatiGiorno
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\RisultatoGiorno[]
     */
    public $risultatiGiorno;
    /**
     * Constructor method for xmlImportRisultati
     * @uses XmlImportRisultati::setRisultatiGiorno()
     * @param \StructType\RisultatoGiorno[] $risultatiGiorno
     */
    public function __construct(array $risultatiGiorno = array())
    {
        $this
            ->setRisultatiGiorno($risultatiGiorno);
    }
    /**
     * Get risultatiGiorno value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\RisultatoGiorno[]|null
     */
    public function getRisultatiGiorno()
    {
        return isset($this->risultatiGiorno) ? $this->risultatiGiorno : null;
    }
    /**
     * Set risultatiGiorno value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\RisultatoGiorno[] $risultatiGiorno
     * @return \StructType\XmlImportRisultati
     */
    public function setRisultatiGiorno(array $risultatiGiorno = array())
    {
        foreach ($risultatiGiorno as $xmlImportRisultatiRisultatiGiornoItem) {
            // validation for constraint: itemType
            if (!$xmlImportRisultatiRisultatiGiornoItem instanceof \StructType\RisultatoGiorno) {
                throw new \InvalidArgumentException(sprintf('The risultatiGiorno property can only contain items of \StructType\RisultatoGiorno, "%s" given', is_object($xmlImportRisultatiRisultatiGiornoItem) ? get_class($xmlImportRisultatiRisultatiGiornoItem) : gettype($xmlImportRisultatiRisultatiGiornoItem)), __LINE__);
            }
        }
        if (is_null($risultatiGiorno) || (is_array($risultatiGiorno) && empty($risultatiGiorno))) {
            unset($this->risultatiGiorno);
        } else {
            $this->risultatiGiorno = $risultatiGiorno;
        }
        return $this;
    }
    /**
     * Add item to risultatiGiorno value
     * @throws \InvalidArgumentException
     * @param \StructType\RisultatoGiorno $item
     * @return \StructType\XmlImportRisultati
     */
    public function addToRisultatiGiorno(\StructType\RisultatoGiorno $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\RisultatoGiorno) {
            throw new \InvalidArgumentException(sprintf('The risultatiGiorno property can only contain items of \StructType\RisultatoGiorno, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->risultatiGiorno[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\XmlImportRisultati
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
